<?php // error_reporting(E_ALL); ini_set('display_errors','On');
/**
*
* @package phpBB3 : style phpBB facebook
* @version 0.0.1
* @copyright (c) 2012 leviatan21	<leviatan21@gmail.com>
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
* Minimum Requirement: PHP 4.3.3
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './../../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
$real_phpbb_root_path = phpbb_root_path();

$ajax = request_var('ajax', '');
if ($ajax != 'true') { echo json_encode(' '); exit(); }

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!defined('IN_AJAX_STATS'))
{
	// Enabled or Disabled ?
	define('IN_AJAX_STATS',				true);
	// 1) Statistics : Total posts · Total topics · Total members · Our newest member
	define('AJAX_GLOBAL_STATISTICS',	true);
	// 2) Who is online
	define('AJAX_WHO_IS_ONLINE',		true);
	// 3) Unread messages
	define('AJAX_UNREAD_POSTS',			true);
	// 4) Newposts messages
	define('AJAX_NEW_POST',				true);
	// 5) Unread private messages
	define('AJAX_PRIVMSGS_INFO',		true);
	// 6/7) Reported post/PM
	define('AJAX_REPORTS_INFO',			true);
	// 8/9) Unapproved topics/post
	define('AJAX_UNAPPROVED_INFO',		true);
	// only return up to 100 result (PM is just a 10%)
	define('SQL_LIMIT',					100);
	// Display also pm,unread,newposts,pm_reports,unapproved_topics,unapproved_topics,unapproved_posts at the same time in fb_leftColContainer and fb_jewelContainer
	define('LEFT_COLUMN_DUPLICATE',		false);
}

//if (!IN_AJAX_STATS || ($user->data['user_id'] == ANONYMOUS || $user->data['is_bot']))
if (!IN_AJAX_STATS || $user->data['is_bot'])
{
	echo json_encode(' '); exit();
}

$user->add_lang(array('common', 'search', 'mcp', 'ucp'));
/**
* like bbcode template :)
**/
$ajax_hardtpl = array(
	'text_noCount'	=> '<li class="sideNavItem" id="navItem_fl_{ID}">'."\n".
							'<div class="item clearfix sortableItem">'."\n".
								'<div class="linkWrap noCount">{TEXT}</div>'."\n".
							'</div>'."\n".
						'</li>',
	'text_hasCount'	=>	'<li class="sideNavItem stat_elem" id="navItem_fl_{ID}">'."\n".
							'<span class="imgWrap"><i class="img general"></i></span>'."\n".
							'<a title="{TITLE}" href="{URL}" class="item clearfix sortableItem">'."\n".
								'<div class="rfloat">'."\n".
									'<span class="count uiSideNavCount">'."\n".
										'<span class="countValue fss">{NUM}</span>'."\n".
									'</span>'."\n".
								'</div>'."\n".
								'<div>'."\n".
									'<div class="linkWrap hasCount">{TEXT}</div>'."\n".
								'</div>'."\n".
							'</a>'."\n".
							'<span class="mover hidden_elem"></span>'."\n".
						'</li>'."\n",
	'text_hasCount2'	=>	'<li class="sideNavItem stat_elem" id="navItem_fl_{ID}">'."\n".
								'<span class="imgWrap"><i class="img general"></i></span>'."\n".
								'<a title="{TITLE}" href="{URL}" class="item clearfix sortableItem" style="min-height: inherit;">'."\n".
									'<div class="rfloat">'."\n".
										'<span class="count uiSideNavCount">'."\n".
											'<span class="countValue fss">{NUM}</span>'."\n".
										'</span>'."\n".
									'</div>'."\n".
								'{TEXT1}</a>'."\n".
							'</li>'."\n".
							'<li class="sideNavItem" id="navItem_fl_{ID}_explain">'."\n".
								'<div class="item clearfix sortableItem" style="min-height: inherit; padding-top: 0;">'."\n".
									'<div class="linkWrap noCount">{TEXT2}</div>'."\n".
								'</div>'."\n".
								'<span class="mover hidden_elem"></span>'."\n".
							'</li>'."\n",
	'separator'		=>	"\n".' &bull; '."\n"
);
fix_phpbb_root_path(null);

$html = '';
// 1) Statistics
if (AJAX_GLOBAL_STATISTICS)
{
	$html .= global_Statistics();
}
// 2) Load online data
if (AJAX_WHO_IS_ONLINE)
{
	$html .= on_line_users();
}
// 3) Unread private messages
$pm_ary = '';
if (AJAX_PRIVMSGS_INFO)
{
	$privmsgs_info = privmsgs_info(SQL_LIMIT/10, LEFT_COLUMN_DUPLICATE);

	$html .= $privmsgs_info['html'];
	$pm_ary = array(
		'url'	=> $privmsgs_info['requestsCountLink'],
		'num'	=> $privmsgs_info['requestsCountValue'],
		'text'	=> $privmsgs_info['requestsCountText']
	);
	unset($privmsgs_info);
}
// 4) Unread messages
$unread_ary = '';
if (AJAX_UNREAD_POSTS)
{
	$unreadposts = unreadposts(SQL_LIMIT, LEFT_COLUMN_DUPLICATE);

	$html .= $unreadposts['html'];
	$unread_ary = array(
		'url'	=> $unreadposts['UnreadMessagesCountLink'],
		'num'	=> $unreadposts['UnreadMessagesCountValue'],
		'text'	=> $unreadposts['UnreadMessagesCountText']
	);

	unset($unreadposts);
}
// 5) newposts messages
$newposts_ary = '';
if (AJAX_NEW_POST)
{
	$newposts = newposts(SQL_LIMIT, LEFT_COLUMN_DUPLICATE);

	$html .= $newposts['html'];
	$newposts_ary = array(
		'url'	=> $newposts['NewMessagesCountLink'],
		'num'	=> $newposts['NewMessagesCountValue'],
		'text'	=> $newposts['NewMessagesCountText']
	);

	unset($newposts);
}
// 6/7) Reported post/PM
$reports_ary = $pm_reports_ary = array();
if (AJAX_REPORTS_INFO && $auth->acl_get('m_report'))
{
	$reports = reports_info('reports', SQL_LIMIT, LEFT_COLUMN_DUPLICATE);
	$html .= $reports['html'];
	$reports_ary = array(
		'url'	=> $reports['reports_link'],
		'num'	=> $reports['reports_value'],
		'text'	=> $reports['reports_text']
	);

	$pm_reports = reports_info('pm_reports', SQL_LIMIT, LEFT_COLUMN_DUPLICATE);
	$html .= $pm_reports['html'];
	$pm_reports_ary = array(
		'url'	=> $pm_reports['reports_link'],
		'num'	=> $pm_reports['reports_value'],
		'text'	=> $pm_reports['reports_text']
	);

	unset($reports, $pm_reports);
}

$unapproved_topics_ary = $unapproved_posts_ary =array();
if (AJAX_UNAPPROVED_INFO && $auth->acl_get('m_approve'))
{
	$unapproved_topics = unapproved_info('unapproved_topics', SQL_LIMIT, LEFT_COLUMN_DUPLICATE);
	$html .= $unapproved_topics['html'];
	$unapproved_topics_ary = array(
		'url'	=> $unapproved_topics['unapproved_link'],
		'num'	=> $unapproved_topics['unapproved_value'],
		'text'	=> $unapproved_topics['unapproved_text']
	);

	$unapproved_posts = unapproved_info('unapproved_posts', SQL_LIMIT, LEFT_COLUMN_DUPLICATE);
	$html .= $unapproved_posts['html'];
	$unapproved_posts_ary = array(
		'url'	=> $unapproved_posts['unapproved_link'],
		'num'	=> $unapproved_posts['unapproved_value'],
		'text'	=> $unapproved_posts['unapproved_text']
	);

	unset($unapproved_topics, $unapproved_posts);
}

echo json_encode(array(
	'statistics'		=> $html,
	/** fb_jewelContainer **/
	'pm'				=> $pm_ary,
	'unread'			=> $unread_ary,
	'newposts'			=> $newposts_ary,
	'reports'			=> $reports_ary,
	'pm_reports'		=> $pm_reports_ary,
	'unapproved_topics'	=> $unapproved_topics_ary,
	'unapproved_posts'	=> $unapproved_posts_ary
));

// As a pre-caution... some setups display a blank page if the flush() is not there.
(ob_get_level() > 0) ? @ob_flush() : @flush();

exit();

function phpbb_root_path()
{
	return generate_board_url() . '/';
}

function fix_phpbb_root_path($return_real = true)
{
	global $phpbb_root_path, $real_phpbb_root_path;
	static $_phpbb_root_path;

	if (empty($_phpbb_root_path))
	{
		global $phpbb_root_path;
		$_phpbb_root_path = $phpbb_root_path;
	}

	if ($return_real === true)
	{
		$phpbb_root_path = $_phpbb_root_path;
	}
	if ($return_real === false)
	{
		$phpbb_root_path = $real_phpbb_root_path;
	}

}
// 1) Statistics
function global_Statistics()
{
	global $ajax_hardtpl;
	global $config;
	global $user;
	global $phpbb_root_path, $real_phpbb_root_path;

	fix_phpbb_root_path(false);
//	$_phpbb_root_path = $phpbb_root_path;
//	$phpbb_root_path = $real_phpbb_root_path;

	$total_posts	= sprintf($user->lang[(($config['num_posts']  == 0) ? 'TOTAL_POSTS_ZERO'  : 'TOTAL_POSTS_OTHER'	)], $config['num_posts']);
	$total_topics	= sprintf($user->lang[(($config['num_topics'] == 0) ? 'TOTAL_TOPICS_ZERO' : 'TOTAL_TOPICS_OTHER')], $config['num_topics']);
	$total_users	= sprintf($user->lang[(($config['num_users']  == 0) ? 'TOTAL_USERS_ZERO'  : 'TOTAL_USERS_OTHER'	)], $config['num_users']);
	$newest_user	= sprintf($user->lang['NEWEST_USER'], get_username_string('full', $config['newest_user_id'], $config['newest_username'], $config['newest_user_colour']));

	$data = array(
		'id'	=> 'global_Statistics',
		'url'	=> '',
		'title'	=> $user->lang['STATISTICS'],
		'num'	=> 0,
		'text'	=> $total_posts . $ajax_hardtpl['separator'] . $total_topics . $ajax_hardtpl['separator'] . $total_users . $ajax_hardtpl['separator'] . $newest_user,
	);

	$html = $ajax_hardtpl['text_noCount'];
	$html = str_replace(array('{ID}'),		array($data['id']),		$html);
	$html = str_replace(array('{TEXT}'),	array($data['text']),	$html);

	fix_phpbb_root_path(true);
//	$phpbb_root_path = $_phpbb_root_path;

	return $html;
}
// 2) Load online data
function on_line_users($display_online_list = true, $item_id = 0, $item = 'forum')
{
	global $ajax_hardtpl;
	global $auth, $db, $user;
	global $config, $phpbb_root_path, $real_phpbb_root_path, $phpEx;

	if ($config['load_online'] && $config['load_online_time'] && $display_online_list)
	{
		/**
		* Load online data:
		* For obtaining another session column use $item and $item_id in the function-parameter, whereby the column is session_{$item}_id.
		*/
		$item_id = max($item_id, 0);

		$online_users = obtain_users_online($item_id, $item);
		$user_online_strings = obtain_users_online_string($online_users, $item_id, $item);

		$l_online_users = $user_online_strings['l_online_users'];
		$online_userlist = $user_online_strings['online_userlist'];
		$total_online_users = $online_users['total_online'];

		if ($total_online_users > $config['record_online_users'])
		{
			set_config('record_online_users', $total_online_users, true);
			set_config('record_online_date', time(), true);
		}

		$l_online_record = sprintf($user->lang['RECORD_ONLINE_USERS'], $config['record_online_users'], $user->format_date($config['record_online_date'], false, true));

		$l_online_time = ($config['load_online_time'] == 1) ? 'VIEW_ONLINE_TIME' : 'VIEW_ONLINE_TIMES';
		$l_online_time = sprintf($user->lang[$l_online_time], $config['load_online_time']);
	}

	// Grab group details for legend display
	if ($auth->acl_gets('a_group', 'a_groupadd', 'a_groupdel'))
	{
		$sql = 'SELECT group_id, group_name, group_colour, group_type
			FROM ' . GROUPS_TABLE . '
			WHERE group_legend = 1
			ORDER BY group_name ASC';
	}
	else
	{
		$sql = 'SELECT g.group_id, g.group_name, g.group_colour, g.group_type
			FROM ' . GROUPS_TABLE . ' g
			LEFT JOIN ' . USER_GROUP_TABLE . ' ug
				ON (
					g.group_id = ug.group_id
					AND ug.user_id = ' . $user->data['user_id'] . '
					AND ug.user_pending = 0
				)
			WHERE g.group_legend = 1
				AND (g.group_type <> ' . GROUP_HIDDEN . ' OR ug.user_id = ' . $user->data['user_id'] . ')
			ORDER BY g.group_name ASC';
	}
	$result = $db->sql_query($sql);

	$legend = array();
	while ($row = $db->sql_fetchrow($result))
	{
		$colour_text = ($row['group_colour']) ? ' style="color:#' . $row['group_colour'] . '"' : '';
		$group_name = ($row['group_type'] == GROUP_SPECIAL) ? $user->lang['G_' . $row['group_name']] : $row['group_name'];
	
		if ($row['group_name'] == 'BOTS' || ($user->data['user_id'] != ANONYMOUS && !$auth->acl_get('u_viewprofile')))
		{
			$legend[] = '<span' . $colour_text . '>' . $group_name . '</span>';
		}
		else
		{
			$legend[] = '<a' . $colour_text . ' href="' . append_sid("{$real_phpbb_root_path}memberlist.$phpEx", 'mode=group&amp;g=' . $row['group_id']) . '">' . $group_name . '</a>';
		}
	}
	$db->sql_freeresult($result);
	
	$legend = '<br /><em>' . $user->lang['LEGEND'] . ': ' . implode(', ', $legend) . '</em>';

	$data = array(
		'id'	=> 'viewonline',
		'url'	=> ($auth->acl_gets('u_viewprofile', 'a_user', 'a_useradd', 'a_userdel')) ? append_sid("{$real_phpbb_root_path}viewonline.$phpEx") : '',
		'title'	=> $user->lang['WHO_IS_ONLINE'],
		'num'	=> $total_online_users,
		'text'	=> $l_online_users . "\n(" . $l_online_time . ")\n<br />" . $l_online_record . "\n<br /><br />" . $online_userlist . "\n" . $legend
	);

	$html = str_replace(array('{ID}', '{TITLE}', '{URL}', '{NUM}', '{TEXT1}', '{TEXT2}'),		array($data['id'], $data['title'], $data['url'], $data['num'], $data['title'], $data['text']),		$ajax_hardtpl['text_hasCount2']);

	return $html;
}
// 3) Unread private messages
function privmsgs_info($limit = SQL_LIMIT, $left = LEFT_COLUMN_DUPLICATE)
{
	global $ajax_hardtpl;
	global $user;
	global $config, $phpbb_root_path, $real_phpbb_root_path, $phpEx;

	$html = '';
	$data = array(
		'id'	=> 'privmsgs_info',
		'url'	=> append_sid("{$real_phpbb_root_path}ucp.$phpEx", array('i' => 'pm', 'folder' => 'inbox')),
		'title'	=> ($user->data['user_unread_privmsg'] <= 1) ? $user->lang['PRIVATE_MESSAGE'] : $user->lang['PRIVATE_MESSAGES'],
		'num'	=> ($user->data['user_unread_privmsg'] < $limit) ? $user->data['user_unread_privmsg'] : $limit . '+',
		'text'	=> ($user->data['user_unread_privmsg'] == 1) ? $user->lang['UNREAD_PM'] : $user->lang['UNREAD_PMS'],
	);

	if (!$left && ($user->data['user_unread_privmsg'] && $user->data['user_unread_privmsg'] != $user->data['user_new_privmsg']))
	{
		$html = str_replace(array('{ID}', '{TITLE}', '{URL}', '{NUM}', '{TEXT}'),		array($data['id'], $data['title'], $data['url'], $data['num'], $data['title']),		$ajax_hardtpl['text_hasCount']);
	}

	return array(
		'html'					=>	$html,
		'requestsCountLink'		=>	$data['url'],
		'requestsCountValue'	=>	(int) $data['num'],
		'requestsCountText'		=>	($user->data['user_unread_privmsg'] == 0)? $user->lang['YOU_NO_NEW_PM'] : '<strong>' . $data['num'] . '</strong> ' . $data['title'],
	);
}
// 4) Unread messages
function unreadposts($limit	= SQL_LIMIT, $left = LEFT_COLUMN_DUPLICATE)
{
	global $ajax_hardtpl;
	global $auth, $db, $user;
	global $config, $phpbb_root_path, $real_phpbb_root_path, $phpEx;

	// Define some vars
	$html				= '';
	$search_id			= 'unreadposts';
	$sql				= '';
	$total_match_count	= 0;
	$start				= max(request_var('start', 0), 0);
	$sort_by_text		= array('a' => $user->lang['SORT_AUTHOR'], 't' => $user->lang['SORT_TIME'], 'f' => $user->lang['SORT_FORUM'], 'i' => $user->lang['SORT_TOPIC_TITLE'], 's' => $user->lang['SORT_POST_SUBJECT']);
	$sort_days			= request_var('st', 0);
	$sort_key			= 't';
	$sort_dir			= request_var('sd', 'd');
	$topic_id			= request_var('t', 0);
	$s_limit_days		= '';
	$s_sort_key			= '';
	$s_sort_dir			= '';
	$u_sort_param		= '';
	$show_results		= ($topic_id) ? 'posts' : request_var('sr', 'posts');
	$show_results		= ($show_results == 'posts') ? 'posts' : 'topics';
	$limit_days			= array(0 => $user->lang['ALL_RESULTS'], 1 => $user->lang['1_DAY'], 7 => $user->lang['7_DAYS'], 14 => $user->lang['2_WEEKS'], 30 => $user->lang['1_MONTH'], 90 => $user->lang['3_MONTHS'], 180 => $user->lang['6_MONTHS'], 365 => $user->lang['1_YEAR']);

	// Which forums should not be searched? - START
	$ex_fid_ary = array_unique(array_merge(array_keys($auth->acl_getf('!f_read', true)), array_keys($auth->acl_getf('!f_search', true))));
	$not_in_fid = (sizeof($ex_fid_ary)) ? 'WHERE ' . $db->sql_in_set('f.forum_id', $ex_fid_ary, true) . " OR (f.forum_password <> '' AND fa.user_id <> " . (int) $user->data['user_id'] . ')' : "";

	if ($not_in_fid)
	{
		$sql = 'SELECT f.forum_id, f.forum_name, f.parent_id, f.forum_type, f.right_id, f.forum_password, f.forum_flags, fa.user_id
			FROM ' . FORUMS_TABLE . ' f
			LEFT JOIN ' . FORUMS_ACCESS_TABLE . " fa ON (fa.forum_id = f.forum_id
				AND fa.session_id = '" . $db->sql_escape($user->session_id) . "')
			$not_in_fid
			ORDER BY f.left_id";
		$result = $db->sql_query($sql);

		$right_id = 0;
		$reset_search_forum = true;
		while ($row = $db->sql_fetchrow($result))
		{
			if ($row['forum_password'] && $row['user_id'] != $user->data['user_id'])
			{
				$ex_fid_ary[] = (int) $row['forum_id'];
				continue;
			}

			// Exclude forums from active topics
			if (!($row['forum_flags'] & FORUM_FLAG_ACTIVE_TOPICS) && ($search_id == 'active_topics'))
			{
				$ex_fid_ary[] = (int) $row['forum_id'];
				continue;
			}
		}
		$db->sql_freeresult($result);
	}
	// Which forums should not be searched? - END

	// find out in which forums the user is allowed to view approved posts
	if ($auth->acl_get('m_approve'))
	{
		$m_approve_fid_ary = array(-1);
		$m_approve_fid_sql = '';
	}
	else if ($auth->acl_getf_global('m_approve'))
	{
		$m_approve_fid_ary = array_diff(array_keys($auth->acl_getf('!m_approve', true)), $ex_fid_ary);
		$m_approve_fid_sql = ' AND (p.post_approved = 1' . ((sizeof($m_approve_fid_ary)) ? ' OR ' . $db->sql_in_set('p.forum_id', $m_approve_fid_ary, true) : '') . ')';
	}
	else
	{
		$m_approve_fid_ary = array();
		$m_approve_fid_sql = ' AND p.post_approved = 1';
	}

	$sort_by_sql['t'] = 't.topic_last_post_time';
	$sql_sort = 'ORDER BY ' . $sort_by_sql[$sort_key] . (($sort_dir == 'a') ? ' ASC' : ' DESC');
	$sql_where = 'AND t.topic_moved_id = 0
					' . str_replace(array('p.', 'post_'), array('t.', 'topic_'), $m_approve_fid_sql) . '
					' . ((sizeof($ex_fid_ary)) ? 'AND ' . $db->sql_in_set('t.forum_id', $ex_fid_ary, true) : '');

//	gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);
	$s_sort_key = $s_sort_dir = $u_sort_param = $s_limit_days = '';

	$unread_list = array();
	$unread_list = get_unread_topics($user->data['user_id'], $sql_where, $sql_sort, $limit);

	$unread_match_count = sizeof($unread_list);

	$data = array(
		'id'	=> 'unreadposts',
		'url'	=> append_sid("{$real_phpbb_root_path}search.$phpEx", array('search_id' => 'unreadposts')),
		'title'	=> $user->lang['UNREAD_MESSAGES'],
		'num'	=> ($unread_match_count < $limit) ? $unread_match_count : $limit . '+',
		'text'	=> ($unread_match_count > 1) ? $user->lang['UNREAD_POSTS'] : $user->lang['UNREAD_POST']
	);

	if ($left && $unread_match_count)
	{
		$html = str_replace(array('{ID}', '{TITLE}', '{URL}', '{NUM}', '{TEXT}'),		array($data['id'], $data['title'], $data['url'], $data['num'], $data['text']),		$ajax_hardtpl['text_hasCount']);
	}

	return array(
		'html'						=>	$html,
		'UnreadMessagesCountLink'	=>	$data['url'],
		'UnreadMessagesCountValue'	=>	(int) $data['num'],
		'UnreadMessagesCountText'	=>	($unread_match_count ==0) ? $user->lang['NO_UNREAD_POSTS'] : '<strong>' . $data['num'] . '</strong> ' .$data['title'],
	);
}
// 5) newposts messages
function newposts($limit = SQL_LIMIT, $left = LEFT_COLUMN_DUPLICATE)
{
	global $ajax_hardtpl;
	global $auth, $db, $user;
	global $config, $phpbb_root_path, $real_phpbb_root_path, $phpEx;

	// Define some vars
	$html				= '';
	$search_id			= 'newposts';
	$start				= max(request_var('start', 0), 0);
	$limit_days			= array(0 => $user->lang['ALL_RESULTS'], 1 => $user->lang['1_DAY'], 7 => $user->lang['7_DAYS'], 14 => $user->lang['2_WEEKS'], 30 => $user->lang['1_MONTH'], 90 => $user->lang['3_MONTHS'], 180 => $user->lang['6_MONTHS'], 365 => $user->lang['1_YEAR']);
	$sort_by_text		= array('a' => $user->lang['SORT_AUTHOR'], 't' => $user->lang['SORT_TIME'], 'f' => $user->lang['SORT_FORUM'], 'i' => $user->lang['SORT_TOPIC_TITLE'], 's' => $user->lang['SORT_POST_SUBJECT']);
	$sort_days			= request_var('st', 0);
	$s_limit_days		= $s_sort_key = $s_sort_dir = $u_sort_param = '';

	// Which forums should not be searched? Author searches are also carried out in unindexed forums
	$ex_fid_ary = array_keys($auth->acl_getf('!f_read', true));

	// find out in which forums the user is allowed to view approved posts
	if ($auth->acl_get('m_approve'))
	{
		$m_approve_fid_ary = array(-1);
		$m_approve_fid_sql = '';
	}
	else if ($auth->acl_getf_global('m_approve'))
	{
		$m_approve_fid_ary = array_diff(array_keys($auth->acl_getf('!m_approve', true)), $ex_fid_ary);
		$m_approve_fid_sql = ' AND (p.post_approved = 1' . ((sizeof($m_approve_fid_ary)) ? ' OR ' . $db->sql_in_set('p.forum_id', $m_approve_fid_ary, true) : '') . ')';
	}
	else
	{
		$m_approve_fid_ary = array();
		$m_approve_fid_sql = ' AND p.post_approved = 1';
	}

	$l_search_title = $user->lang['SEARCH_NEW'];
	// force sorting
	$show_results = (request_var('sr', 'topics') == 'posts') ? 'posts' : 'topics';
	$sort_key = 't';
	$sort_dir = 'd';
	$sort_by_sql['t'] = ($show_results == 'posts') ? 'p.post_time' : 't.topic_last_post_time';
	$sql_sort = 'ORDER BY ' . $sort_by_sql[$sort_key] . (($sort_dir == 'a') ? ' ASC' : ' DESC');

//	gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);
	$s_sort_key = $s_sort_dir = $u_sort_param = $s_limit_days = '';

	if ($show_results == 'posts')
	{
		$sql = 'SELECT p.post_id
			FROM ' . POSTS_TABLE . ' p
			WHERE p.post_time > ' . $user->data['user_lastvisit'] . "
				$m_approve_fid_sql
				" . ((sizeof($ex_fid_ary)) ? ' AND ' . $db->sql_in_set('p.forum_id', $ex_fid_ary, true) : '') . "
			$sql_sort";
		$field = 'post_id';
	}
	else
	{
		$sql = 'SELECT t.topic_id
			FROM ' . TOPICS_TABLE . ' t
			WHERE t.topic_last_post_time > ' . $user->data['user_lastvisit'] . '
				AND t.topic_moved_id = 0
				' . str_replace(array('p.', 'post_'), array('t.', 'topic_'), $m_approve_fid_sql) . '
				' . ((sizeof($ex_fid_ary)) ? 'AND ' . $db->sql_in_set('t.forum_id', $ex_fid_ary, true) : '') . "
			$sql_sort";
/*
[Fix] queued replies missing from "view new posts" (Bug #42705 - Patch by Paul)
- Creates temporary table, query is far from optimized

		$sql = 'SELECT t.topic_id
			FROM ' . TOPICS_TABLE . ' t, ' . POSTS_TABLE . ' p
			WHERE p.post_time > ' . $user->data['user_lastvisit'] . '
				AND t.topic_id = p.topic_id
				AND t.topic_moved_id = 0
				' . $m_approve_fid_sql . '
				' . ((sizeof($ex_fid_ary)) ? 'AND ' . $db->sql_in_set('t.forum_id', $ex_fid_ary, true) : '') . "
			GROUP BY t.topic_id
			$sql_sort";
*/
		$field = 'topic_id';
	}

	// only return up to 1000 ids (the last one will be removed later)
	$result = $db->sql_query_limit($sql, $limit - $start, $start);

	// clear arrays
	$id_ary = array();

	while ($row = $db->sql_fetchrow($result))
	{
		$id_ary[] = (int) $row[$field];
	}
	$db->sql_freeresult($result);

	$total_match_count = sizeof($id_ary) + $start;

	$data = array(
		'id'	=> 'newposts',
		'url'	=> append_sid("{$real_phpbb_root_path}search.$phpEx", array('search_id' => 'newposts', 'sr' => 'posts')),
		'title'	=> $user->lang['NEW_POSTS'],
		'num'	=> ($total_match_count < $limit) ? $total_match_count : $total_match_count.'+',
		'text'	=> ($total_match_count > 1) ? $user->lang['NEW_POSTS'] : $user->lang['NEW_POST']
	);

	if ($left && $total_match_count)
	{
		$html = $ajax_hardtpl['text_hasCount'];

		$html = str_replace(array('{ID}'),		array($data['id']),		$html);
		$html = str_replace(array('{TITLE}'),	array($data['title']),	$html);
		$html = str_replace(array('{URL}'),		array($data['url']),	$html);
		$html = str_replace(array('{NUM}'),		array($data['num']),	$html);
		$html = str_replace(array('{TEXT}'),	array($data['text']),	$html);
	}

	return array(
		'html'					=>	$html,
		'NewMessagesCountLink'	=>	$data['url'],
		'NewMessagesCountValue'	=>	(int) $data['num'],
		'NewMessagesCountText'	=>	($total_match_count == 0) ? $user->lang['NO_NEW_MESSAGES'] : '<strong>' . $data['num'] . '</strong> ' . $data['text'],
	);
}
// 6/7) Reported post/PM
function reports_info($mode = 'reports', $limit = SQL_LIMIT, $left = LEFT_COLUMN_DUPLICATE)
{
	global $ajax_hardtpl;
	global $auth, $db, $user;
	global $phpbb_root_path, $real_phpbb_root_path, $phpEx;

	include_once($phpbb_root_path . 'includes/functions_admin.' . $phpEx);

	$html			= '';
	$reports_info	= 0;
	$where_sql		= 'WHERE';
	$mode			= request_var('mode', $mode);
	$topic_id		= request_var('t', 0);
	$forum_id		= request_var('f', 0);
	$sort_days		= request_var('st', 0);
	$min_time		= ($sort_days) ? time() - ($sort_days * 86400) : 0;
	$limit_time_sql = ($min_time) ? "AND r.report_time >= $min_time" : '';
	$pm				= (strpos($mode, 'pm_') === 0) ? true : false;
	$type			= ($pm) ? 'pm_reports' : 'reports';
	$default_key	= 't';
	$default_dir	= 'd';
	$limit_time_sql = ($min_time) ? "AND r.report_time >= $min_time" : '';

	if ($topic_id)
	{
		$where_sql .= ' p.topic_id = ' . $topic_id . ' AND ';
	}
	else if ($forum_id)
	{
		$where_sql .= ' p.forum_id = ' . $forum_id . ' AND ';
	}
	else if (!$pm)
	{
		$where_sql .= ' ' . $db->sql_in_set('p.forum_id', get_forum_list(array('!f_read', '!m_report')), true, true) . ' AND ';
	}

	if ($mode == 'reports' || $mode == 'pm_reports')
	{
		$where_sql .= ' r.report_closed = 0 AND ';
	}
	else
	{
		$where_sql .= ' r.report_closed = 1 AND ';
	}

	if ($pm)
	{
		$title = $user->lang['MCP_PM_REPORTS'];
		$sql = 'SELECT COUNT(r.report_id) AS total
			FROM ' . REPORTS_TABLE . ' r, ' . PRIVMSGS_TABLE . " p
			$where_sql r.post_id = 0
				AND p.msg_id = r.pm_id
				$limit_time_sql";
	}
	else
	{
		$title = $user->lang['MCP_REPORTS'];
		$sql = 'SELECT COUNT(r.report_id) AS total
			FROM ' . REPORTS_TABLE . ' r, ' . POSTS_TABLE . " p
			$where_sql r.pm_id = 0
				AND p.post_id = r.post_id
				$limit_time_sql";
	}

	$result = $db->sql_query($sql);
	$total = (int) $db->sql_fetchfield('total');
	$db->sql_freeresult($result);

	$data = array(
		'id'	=> 'info_' . $mode,
		'url'	=> ($mode == 'reports') ? append_sid("{$real_phpbb_root_path}mcp.$phpEx", array('i' => 'reports', 'mode' => 'reports')) : append_sid("{$phpbb_root_path}mcp.$phpEx", array('i' => 'pm_reports', 'mode' => 'pm_report_details', 'r' =>2)),
		'title'	=> $title,
		'num'	=> ($total < $limit) ? $total : $total.'+',
		'text'	=> $title
	);

	if ($left && $total)
	{
		$html = str_replace(array('{ID}', '{TITLE}', '{URL}', '{NUM}', '{TEXT}'),		array($data['id'], $data['title'], $data['url'], $data['num'], $data['text']),		$ajax_hardtpl['text_hasCount']);
	}

	return array(
		'html'			=>	$html,
		'reports_link'	=>	$data['url'],
		'reports_value'	=>	(int) $data['num'],
		'reports_text'	=>	($total == 0) ? $user->lang['NO_REPORTS'] : $data['title'] . ' <strong>' . $data['num'] . '</strong>',
	);
}
// 8/9) Unapproved topics/post
function unapproved_info($mode = 'unapproved_topics', $limit = SQL_LIMIT, $left = LEFT_COLUMN_DUPLICATE)
{
	global $ajax_hardtpl;
	global $auth, $db, $user;
	global $phpbb_root_path, $real_phpbb_root_path, $phpEx;

	include_once($phpbb_root_path . 'includes/functions_admin.' . $phpEx);

	$html			= '';
	$where_sql 		= 'WHERE';
	$mode			= request_var('mode', $mode);
	$topic_id		= request_var('t', 0);
	$forum_id		= request_var('f', 0);
	$sort_days		= request_var('st', 0);
	$min_time		= ($sort_days) ? time() - ($sort_days * 86400) : 0;

	switch ($mode)
	{
		case 'unapproved_posts':
			$title = $user->lang['MCP_QUEUE_UNAPPROVED_POSTS'];
			$type = 'posts';
			$default_key = 't';
			$default_dir = 'd';
			$where_sql .= ($topic_id) ? ' p.topic_id = ' . $topic_id . ' AND' : '';

			$sql = 'SELECT COUNT(p.post_id) AS total
				FROM ' . POSTS_TABLE . ' p, ' . TOPICS_TABLE . " t
				$where_sql " . $db->sql_in_set('p.forum_id', ($forum_id) ? array($forum_id) : array_intersect(get_forum_list('f_read'), get_forum_list('m_approve'))) . '
					AND p.post_approved = 0
					AND t.topic_id = p.topic_id
					AND t.topic_first_post_id <> p.post_id';

			if ($min_time)
			{
				$sql .= ' AND post_time >= ' . $min_time;
			}
		break;

		case 'unapproved_topics':
			$title = $user->lang['MCP_QUEUE_UNAPPROVED_TOPICS'];
			$type = 'topics';
			$default_key = 't';
			$default_dir = 'd';

			$sql = 'SELECT COUNT(topic_id) AS total
				FROM ' . TOPICS_TABLE . "
				$where_sql " . $db->sql_in_set('forum_id', ($forum_id) ? array($forum_id) : array_intersect(get_forum_list('f_read'), get_forum_list('m_approve'))) . '
					AND topic_approved = 0';

			if ($min_time)
			{
				$sql .= ' AND topic_time >= ' . $min_time;
			}
		break;
	}

	$result = $db->sql_query($sql);
	$total = (int) $db->sql_fetchfield('total');
	$db->sql_freeresult($result);

	$data = array(
		'id'	=> 'info_' . $mode,
		'url'	=> append_sid("{$real_phpbb_root_path}mcp.$phpEx", array('i' => 'reports')),
		'title'	=> $title,
		'num'	=> ($total < $limit) ? $total : $total.'+',
		'text'	=> $title
	);

	if ($left && $total)
	{
		$html = str_replace(array('{ID}', '{TITLE}', '{URL}', '{NUM}', '{TEXT}'),		array($data['id'], $data['title'], $data['url'], $data['num'], $data['text']),		$ajax_hardtpl['text_hasCount']);
	}

	return array(
		'html'				=>	$html,
		'unapproved_link'	=>	$data['url'],
		'unapproved_value'	=>	(int) $data['num'],
		'unapproved_text'	=>	($total == 0 ) ? (($mode == 'unapproved_topics') ? $user->lang['NO_TOPICS_QUEUE'] : $user->lang['UNAPPROVED_POSTS_ZERO_TOTAL']) : $data['title'] . ' <strong>' . $data['num'] . '</strong>',
	);
	return $html;
}

?>